#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include <omp.h>

int main(void)
{
  int N;

  double pi, exactpi;

  int i;

  N = 840;

  printf("Hello from thread %d out of %d\n",
	 omp_get_thread_num(), omp_get_num_threads());

  printf("Computing approximation to pi using N = %d\n", N);


#pragma omp parallel
  {
    printf("Hello from thread %d out of %d\n",
	   omp_get_thread_num(), omp_get_num_threads());
  }

  pi = 0.0;

#pragma omp parallel for \
  default(none) private(i) shared(N) reduction(+:pi)

  for (i=1; i<=N; i++)
    {
      pi = pi + 1.0/( 1.0 + pow( (((double) i)-0.5)/((double) N), 2.0) );
    }

  pi = pi * 4.0/((double) N);

  exactpi = 4.0*atan(1.0);
  
  printf("pi = %f, %% error = %f\n", pi, fabs(100.0*(pi-exactpi)/exactpi));

  return 0;
}
